﻿
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Diagnostics;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.Script.Services;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.DataSources;
using Syncfusion.Linq;
using Syncfusion.JavaScript.Web;
using System.Web.Services;
using SyncfusionASPNETApplication21.Models;
using System.Data.SqlClient;
using System.Configuration;

namespace SyncfusionASPNETApplication21
{
    public partial class KanbanFeatures : System.Web.UI.Page
    {
        DataTable dt = new DataTable("Task");
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                //Render all kanban cards.
                SqlConnection myConnection = new SqlConnection(ConfigurationManager.ConnectionStrings["SQLConnectionString"].ToString());
                dt = new DataTable("Task");
                SqlCommand cmd = new SqlCommand();
                cmd.Connection = myConnection;
                cmd.CommandText = "select * from Tasks";
                cmd.CommandType = CommandType.Text;
                SqlDataAdapter da = new SqlDataAdapter();
                da.SelectCommand = cmd;
                if (myConnection.State == ConnectionState.Closed)
                {
                    myConnection.Open();
                }
                da.Fill(dt);
                //To render all Kanban cards.
                Kanban.DataSource = (DataTable)dt;
                Kanban.DataBind();
            }
        }
        //Perform Edit Operation
        [WebMethod]
        [ScriptMethod(ResponseFormat = ResponseFormat.Json)]
        public static object EditDropAction(int Id, string Status, string Assignee, float Estimate, string Summary)
        {
            SqlConnection myConnection = new SqlConnection(ConfigurationManager.ConnectionStrings["SQLConnectionString"].ToString());
            if (myConnection.State == ConnectionState.Closed)
            {
                myConnection.Open();
            }
            string updateQuery = "UPDATE Tasks SET Assignee=@Assignee, Summary=@Summary, Estimate=@Estimate, Status=@Status where Id=@Id";
            SqlCommand UpdateCmd = new SqlCommand(updateQuery, myConnection);
            UpdateCmd.Parameters.Add(new SqlParameter("@Assignee", SqlDbType.VarChar, 10)).Value = Assignee;
            UpdateCmd.Parameters.Add(new SqlParameter("@Summary", SqlDbType.VarChar, 150)).Value = Summary;
            UpdateCmd.Parameters.Add(new SqlParameter("@Estimate", SqlDbType.Float)).Value = Estimate;
            UpdateCmd.Parameters.Add(new SqlParameter("@Status", SqlDbType.VarChar, 10)).Value = Status;
            UpdateCmd.Parameters.Add(new SqlParameter("@Id", SqlDbType.Int)).Value = Id; 
            UpdateCmd.ExecuteNonQuery();
            var ID = Id;
            return ID;
        }
        //Perform Add Operation
        [WebMethod]
        [ScriptMethod(ResponseFormat = ResponseFormat.Json)]
        public static object AddAction(int Id, string Status, string Assignee, float Estimate, string Summary)
        {
            SqlConnection myConnection = new SqlConnection(ConfigurationManager.ConnectionStrings["SQLConnectionString"].ToString());
            if (myConnection.State == ConnectionState.Closed)
            {
                myConnection.Open();
            }
            string insertQuery = "INSERT INTO Tasks(Assignee,Summary,Estimate,Status,Id,RankId) VALUES (@Assignee,@Summary,@Estimate,@Status,@Id,@RankId)";
            SqlCommand InsertCmd = new SqlCommand(insertQuery, myConnection);
            InsertCmd.Parameters.Add(new SqlParameter("@Assignee", SqlDbType.VarChar, 10)).Value = Assignee;
            InsertCmd.Parameters.Add(new SqlParameter("@Summary", SqlDbType.VarChar, 150)).Value = Summary;
            InsertCmd.Parameters.Add(new SqlParameter("@Estimate", SqlDbType.Float)).Value = Estimate;
            InsertCmd.Parameters.Add(new SqlParameter("@Status", SqlDbType.VarChar, 10)).Value = Status;
            InsertCmd.Parameters.Add(new SqlParameter("@Id", SqlDbType.Int)).Value = Id;
            InsertCmd.Parameters.Add(new SqlParameter("@RankId", SqlDbType.Int)).Value = 0;
            InsertCmd.ExecuteNonQuery();
            var ID = Id;
            return ID;
        }
        //Perform Remove Operation
        [WebMethod]
        [ScriptMethod(ResponseFormat = ResponseFormat.Json)]
        public static object removeAction(int Id, string Status, string Assignee, float Estimate, string Summary)
        {
            SqlConnection myConnection = new SqlConnection(ConfigurationManager.ConnectionStrings["SQLConnectionString"].ToString());
            if (myConnection.State == ConnectionState.Closed)
            {
                myConnection.Open();
            }
            string deleteQuery = "DELETE from Tasks where Id='" + Id + "'";
            SqlCommand deleteCmd = new SqlCommand(deleteQuery, myConnection);
            deleteCmd.ExecuteNonQuery();
            var ID = Id;
            return ID;
        }
    }
}